import React from "react";
import { MdCancel } from "react-icons/md";

import styles from './styles.module.css';
import { Checkbox } from "../../components/base/checkbox/Index";

const List = ({
  store,
  editIndex,
  renderEditableContent,
  startEdit,
  toggleComplete,
  Delete
}) => {
  return (
    <ul className={styles.scroll}>
      {store.map((item, index) => {
        if (!item || typeof item.task === 'undefined') return null;

        return (
          <li key={item.id ?? index} className={`${styles.todo} ${item.completed ? styles.completed : ""}`}>
            <div className={styles.check}>
              <Checkbox
                checked={item.completed}
              onChange={() => toggleComplete(index)}
              id={item.id}
              />
              {editIndex === index ? (
                renderEditableContent()
              ) : (
                <span
                  className={`${styles.task} ${item.completed ? styles.completed : ''}`}
                  onClick={() => startEdit(index)}
                >
                  {typeof item.task === 'string'
                    ? item.task
                    : JSON.stringify(item.task)}
                </span>
              )}
            </div>
            <button className={styles.delete} onClick={() => Delete(item.id)}>
              <MdCancel />
            </button>
          </li>
        );
      })}
    </ul>
  );
};

export default List;
